import AbstractModel from './abstractModel'
import UserModel from './user'
import TaskModel from './task'

import type {IBucket} from '@/modelTypes/IBucket'
import type {ITask} from '@/modelTypes/ITask'
import type {IUser} from '@/modelTypes/IUser'

export default class BucketModel extends AbstractModel<IBucket> implements IBucket {
	id = 0
	title = ''
	listId = ''
	limit = 0
	tasks: ITask[] = []
	isDoneBucket = false
	position = 0
	
	createdBy: IUser = null
	created: Date = null
	updated: Date = null

	constructor(data: Partial<IBucket>) {
		super()
		this.assignData(data, (data) => {
			return {
				...data,
				tasks: data.tasks.map(t => new TaskModel(t)),

				createdBy: new UserModel(data.createdBy),
				created: new Date(data.created),
				updated: new Date(data.updated),
			}
		})


	}
}